<?php
/*------------------------------------------------------------------------
# plg_zhyandexmap - Zh YandexMap Plugin
# ------------------------------------------------------------------------
# author    Dmitry Zhuk
# copyright Copyright (C) 2011 zhuk.cc. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 or later
# Websites: http://zhuk.cc
# Technical Support:  Development Page - http://zhuk.cc/?page_id=605
-------------------------------------------------------------------------*/
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.plugin.plugin' );

class plgContentPlg_ZhYandexMap extends JPlugin
{	
	
	var $loadmodules;

	var $scripthead;
	var $scripttext;
	
	var $compatiblemodersf;


	function parse_route_by_markers($markerId)
	{

		if ((int)$markerId != 0)
		{
			$dbMrk = JFactory::getDBO();

			$queryMrk = $dbMrk->getQuery(true);
			$queryMrk->select('h.*')
				->from('#__zhyandexmaps_markers as h')
				->where('h.id = '.(int) $markerId);
			$dbMrk->setQuery($queryMrk);        
			$myMarker = $dbMrk->loadObject();
			
			if (isset($myMarker))
			{
				if ($myMarker->latitude != "" && $myMarker->longitude != "")
				{
					return 'new YMaps.GeoPoint('.$myMarker->longitude.', ' .$myMarker->latitude.')';
				}
				else
				{
					return 'geocode';
				}
			}
			else
			{
				return '';
			}
		
		}

	}


	function get_userinfo_for_marker($userId, $showuser)
	{

		if ($this->compatiblemodersf == 0)
		{
			$imgpathIcons = JURI::root() .'administrator/components/com_zhyandexmap/assets/icons/';
			$imgpathUtils = JURI::root() .'administrator/components/com_zhyandexmap/assets/utils/';
		}
		else
		{
			$imgpathIcons = JURI::root() .'components/com_zhyandexmap/assets/icons/';
			$imgpathUtils = JURI::root() .'components/com_zhyandexmap/assets/utils/';
		}
		
		if ((int)$userId != 0)
		{
			$cur_user_name = '';
			$cur_user_address = '';
			$cur_user_phone = '';
			
			$dbUsr = JFactory::getDBO();
			$queryUsr = $dbUsr->getQuery(true);
			
			$queryUsr->select('p.*, h.name as profile_username')
				->from('#__users as h')
				->leftJoin('#__user_profiles as p ON p.user_id=h.id')
				->where('h.id = '.(int)$userId);

			$dbUsr->setQuery($queryUsr);        
			$myUsr = $dbUsr->loadObjectList();
			
			if (isset($myUsr))
			{
				
				foreach ($myUsr as $key => $currentUsers) 
				{
					$cur_user_name = $currentUsers->profile_username;

					if ($currentUsers->profile_key == 'profile.address1')
					{
						$cur_user_address = $currentUsers->profile_value;
					}
					else if ($currentUsers->profile_key == 'profile.phone')
					{
						$cur_user_phone = $currentUsers->profile_value;
					}
					
					
				}
				
				$cur_scripttext = '';
				
				if (isset($showuser) && ((int)$showuser != 0))
				{
					switch ((int)$showuser) 
					{
						case 1:
							if ($cur_user_name != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.JText::_('PLG_ZHGOOGLEMAP_MAP_USER_USER_NAME').' '.htmlspecialchars(str_replace('\\', '/', $cur_user_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
							if ($cur_user_address != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.JText::_('PLG_ZHGOOGLEMAP_MAP_USER_USER_ADDRESS').' '.str_replace('<br /><br />', '<br />',str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $cur_user_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
							}
							if ($cur_user_phone != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.JText::_('PLG_ZHGOOGLEMAP_MAP_USER_USER_PHONE').' '.htmlspecialchars(str_replace('\\', '/', $cur_user_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
						break;
						case 2:
							if ($cur_user_name != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.htmlspecialchars(str_replace('\\', '/', $cur_user_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
							if ($cur_user_address != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser"><img src="'.$imgpathUtils.'address.png" alt="'.JText::_('PLG_ZHGOOGLEMAP_MAP_USER_USER_ADDRESS').'" />'.str_replace('<br /><br />', '<br />',str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $cur_user_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
							}
							if ($cur_user_phone != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser"><img src="'.$imgpathUtils.'phone.png" alt="'.JText::_('PLG_ZHGOOGLEMAP_MAP_USER_USER_PHONE').'" />'.htmlspecialchars(str_replace('\\', '/', $cur_user_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
						break;
						case 3:
							if ($cur_user_name != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.htmlspecialchars(str_replace('\\', '/', $cur_user_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
							if ($cur_user_address != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.str_replace('<br /><br />', '<br />',str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $cur_user_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
							}
							if ($cur_user_phone != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.htmlspecialchars(str_replace('\\', '/', $cur_user_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
						break;
						default;
							if ($cur_user_name != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.htmlspecialchars(str_replace('\\', '/', $cur_user_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
							if ($cur_user_address != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.str_replace('<br /><br />', '<br />',str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $cur_user_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
							}
							if ($cur_user_phone != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.htmlspecialchars(str_replace('\\', '/', $cur_user_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
						break;										
					}
				}
				
				return $cur_scripttext;
			}
			else
			{
				return '';
			}	
		}
		else
		{
			return '';
		}	
	}
	
	public function onContentPrepare($context, &$article, &$params, $limitstart)
	{
		$app = JFactory::getApplication();

        $comparams = JComponentHelper::getParams( 'com_zhyandexmap' );

		$apikey = $comparams->get( 'map_key');
		$mapVersion = "1.1";

		$this->compatiblemodersf = $comparams->get( 'map_compatiblemode_rsf');
		
		if ($this->compatiblemodersf == 0)
		{
			$imgpathLightbox = JURI::root() .'administrator/components/com_zhyandexmap/assets/lightbox/';
		}
		else
		{
			$imgpathLightbox = JURI::root() .'components/com_zhyandexmap/assets/lightbox/';
		}
		

		$document	= JFactory::getDocument();

		// Load plugin language
		JPlugin::loadLanguage();
		
		$scriptlink	= 'http://api-maps.yandex.ru/'.$mapVersion.'/index.xml?key='. $apikey ;

		$regexLght		= '/({zhyandexmap-lightbox:\s*)(.*?)(})/is';
		$matchesLght 		= array();
		$count_matches_Lght	= preg_match_all($regexLght, $article->text, $matchesLght, PREG_PATTERN_ORDER | PREG_OFFSET_CAPTURE);

		$regexMrk		= '/({zhyandexmap-marker:\s*)(.*?)(})/is';
		$matchesMrk 		= array();
		$count_matches_Mrk	= preg_match_all($regexMrk, $article->text, $matchesMrk, PREG_PATTERN_ORDER | PREG_OFFSET_CAPTURE);

		$regexGrp		= '/({zhyandexmap-group:\s*)(.*?)(})/is';
		$matchesGrp 		= array();
		$count_matches_Grp	= preg_match_all($regexGrp, $article->text, $matchesGrp, PREG_PATTERN_ORDER | PREG_OFFSET_CAPTURE);

		$regexCategory		= '/({zhyandexmap-category:\s*)(.*?)(})/is';
		$matchesCategory 		= array();
		$count_matches_Category	= preg_match_all($regexCategory, $article->text, $matchesCategory, PREG_PATTERN_ORDER | PREG_OFFSET_CAPTURE);
		
		$regexMap		= '/({zhyandexmap:\s*)(.*?)(})/is';
		$matchesMap 		= array();
		$count_matches_Map	= preg_match_all($regexMap, $article->text, $matchesMap, PREG_PATTERN_ORDER | PREG_OFFSET_CAPTURE);

		if (($count_matches_Map > 0) ||
            ($count_matches_Mrk > 0) ||
            ($count_matches_Grp > 0) ||
            ($count_matches_Category > 0)||
			($count_matches_Lght > 0))
		{

			// Begin loop for Map
			for($i = 0; $i < $count_matches_Map; $i++) 
			{
			  //$article->text .= "\n" .'<br />-1-'. $matches[0][$i][0];
 			  //$article->text .= "\n" .'<br />-2-'. $matches[1][$i][0];
			  //$article->text .= "\n" .'<br />-3-'. $matches[2][$i][0];
			  //$article->text .= "\n" .'<br />-4-'. $matches[3][$i][0];
			    if (property_exists($article, "id"))
				{
					$cur_article_id = $article->id;
				}
				else
				{
					$cur_article_id ="";
				}

				$compoundID = str_replace('#','_', str_replace('.', '_', $context.'#'.$cur_article_id .'#'.$i));
				$pars = explode(";", $matchesMap[2][$i][0]);
				$basicID = $pars[0];
				$compoundID .= '_'.$basicID.'_'.'0';

				if ($this->getMap($matchesMap[2][$i][0], $compoundID, 0, 0, 0))
				{
					$patternsMap = '/'.$matchesMap[0][$i][0].'/';
					$document->addScript($scriptlink . $this->loadmodules);
					$replacementsMap = $this->scripthead . $this->scripttext; //'call='.$i ;
					$article->text = preg_replace($patternsMap, $replacementsMap, $article->text, 1);
				}
			}
			// End loop for Map

			// Begin loop for Marker
			for($i = 0; $i < $count_matches_Mrk; $i++) 
			{
			    if (property_exists($article, "id"))
				{
					$cur_article_id = $article->id;
				}
				else
				{
					$cur_article_id ="";
				}

				$compoundID = str_replace('#','_', str_replace('.', '_', $context.'#'.$cur_article_id .'#'.$i));
				$pars = explode(";", $matchesMrk[2][$i][0]);
				$basicID = $pars[0];
				$compoundID .= '_'.$basicID.'_'.'0';

				if ($this->getMap(0, $compoundID, $matchesMrk[2][$i][0], 0, 0))
				{
					$patternsMrk = '/'.$matchesMrk[0][$i][0].'/';
					$document->addScript($scriptlink . $this->loadmodules);
					$replacementsMrk = $this->scripthead . $this->scripttext; 
					$article->text = preg_replace($patternsMrk, $replacementsMrk, $article->text, 1);
				}
			}
			// End loop for Marker
			
			// Begin loop for Group
			for($i = 0; $i < $count_matches_Grp; $i++) 
			{
			    if (property_exists($article, "id"))
				{
					$cur_article_id = $article->id;
				}
				else
				{
					$cur_article_id ="";
				}

				$compoundID = str_replace('#','_', str_replace('.', '_', $context.'#'.$cur_article_id .'#'.$i));
				$pars = explode(";", $matchesGrp[2][$i][0]);
				$basicID = $pars[0];
				$compoundID .= '_'.$basicID.'_'.'0';

				if ($this->getMap(0, $compoundID, 0, $matchesGrp[2][$i][0], 0))
				{
					$patternsGrp = '/'.$matchesGrp[0][$i][0].'/';
					$document->addScript($scriptlink . $this->loadmodules);
					$replacementsGrp = $this->scripthead . $this->scripttext; 
					$article->text = preg_replace($patternsGrp, $replacementsGrp, $article->text, 1);
				}
			}
			// End loop for Group
			
			// Begin loop for Category
			for($i = 0; $i < $count_matches_Category; $i++) 
			{
			    if (property_exists($article, "id"))
				{
					$cur_article_id = $article->id;
				}
				else
				{
					$cur_article_id ="";
				}

				$compoundID = str_replace('#','_', str_replace('.', '_', $context.'#'.$cur_article_id .'#'.$i));
				$pars = explode(";", $matchesCategory[2][$i][0]);
				$basicID = $pars[0];
				$compoundID .= '_'.$basicID.'_'.'0';

				if ($this->getMap(0, $compoundID, 0, 0, $matchesCategory[2][$i][0]))
				{
					$patternsCategory = '/'.$matchesCategory[0][$i][0].'/';
					$document->addScript($scriptlink . $this->loadmodules);
					$replacementsCategory = $this->scripthead . $this->scripttext; 
					$article->text = preg_replace($patternsCategory, $replacementsCategory, $article->text, 1);
				}
			}
			// End loop for Category
			
			// Begin loop for Lightbox
			for($i = 0; $i < $count_matches_Lght; $i++) 
			{

				$pars = explode(";", $matchesLght[2][$i][0]);
				$mapid = $pars[0];
				$popupTitle = htmlspecialchars($pars[1], ENT_QUOTES, 'UTF-8');
				$mapwidth = $pars[2];
				$mapheight = $pars[3];
				$mapimage = $pars[4];
				
			
				JHTML::_('behavior.modal', 'a.zhym-modal-button');

				if ((!isset($mapwidth)) || (isset($mapwidth) && (int)$mapwidth < 1)) 
				{
					$popupWidth = 700;
				}
				else
				{
					$popupWidth = (int)$mapwidth;
				}
				
				if ((!isset($mapheight)) || (isset($mapheight) && (int)$mapheight < 1)) 
				{
					$popupHeight = 500;
				}
				else
				{
					$popupHeight = (int)$mapheight;
				}
				if ((!isset($popupTitle) || (isset($popupTitle) && $popupTitle ==""))
				 && (!isset($mapimage) || (isset($mapimage) && $mapimage =="")))
				{
					$popupTitle = JText::_('PLG_ZHYANDEXMAP_MAP_LIGHTBOX_SHOW_MAP');
					//$popupTitle = 'Показать карту';
				}
				
				if (isset($mapimage) && $mapimage !="")
				{
					$popupImage = '<img src="'.$imgpathLightbox.$mapimage.'" alt="" />';
				}
				else
				{
					$popupImage = '';
				}

				if (isset($mapid) && (int)$mapid != 0)
				{
					$popupOptions = "{handler: 'iframe', size: {x: ".$popupWidth.", y: ".$popupHeight."} }";
					$popupCall = JRoute::_('index.php?option=com_zhyandexmap&view=zhyandexmap&tmpl=component&id='.(int)$mapid);

					$replacementsLght = '<a class="zhym-modal-button" title="'.$popupTitle.'" href="'.$popupCall.'" rel="'.$popupOptions.'">'.$popupImage.$popupTitle.'</a>';
					
					$patternsLght = '/'.$matchesLght[0][$i][0].'/';
					
					$article->text = preg_replace($patternsLght, $replacementsLght, $article->text, 1);
				}
				
			}
			// End loop for Lightbox
                        
		}



		return true;

	}

	function getAddPlacemarkWhere($mf)
	{
		$addWhere = "";

		if ($mf == 1)
		{			
			$currentUser = JFactory::getUser();

			// Filter by user
			if ((int)$currentUser->id == 0)
			{
				// if NOT logged in, then can see YOURS - published
				$addWhere = 'and h.published=1 and h.createdbyuser='.(int)$currentUser->id;
			}
			else
			{
				// if logged in, then can see YOURS - all
				$addWhere = 'and h.createdbyuser='.(int)$currentUser->id;
			}
		}
		else
		{
			// There is not entering data and filter control
			$addWhere = 'and h.published=1';
		}

		return $addWhere;
	}
	
	function getMap($id, $currentArticleId, $placemarkIdWithPars, $groupIdWithPars, $categoryIdWithPars)
	{      
		if ($this->compatiblemodersf == 0)
		{
			$imgpathIcons = JURI::root() .'administrator/components/com_zhyandexmap/assets/icons/';
			$imgpathUtils = JURI::root() .'administrator/components/com_zhyandexmap/assets/utils/';
			$imgpathLightbox = JURI::root() .'administrator/components/com_zhyandexmap/assets/lightbox/';
		}
		else
		{
			$imgpathIcons = JURI::root() .'components/com_zhyandexmap/assets/icons/';
			$imgpathUtils = JURI::root() .'components/com_zhyandexmap/assets/utils/';
			$imgpathLightbox = JURI::root() .'components/com_zhyandexmap/assets/lightbox/';
		}
		

		// Value in (placemark, map)
		$currentCenter = "map";
		// Value in (1.., do not change)
		$currentZoom = "do not change";

		// Map Type Value
		$currentMapType ="do not change";
		$currentMapTypeValue ="";

		// Size Value 
		$currentMapWidth ="do not change";
		$currentMapHeight ="do not change";
		
		if (((int)$id==0) &&
			($placemarkIdWithPars !="") &&
			($groupIdWithPars !="") &&
			($categoryIdWithPars !="") 
			) 
		{
			return false;
		}

		$db = JFactory::getDBO();
		$addFilterWhere = "";
	
        if ((int)$id !=0)
        {
            $query = $db->getQuery(true);
            $query->select('h.*')
                ->from('#__zhyandexmaps_maps as h')
                ->where('h.id = '.(int)$id);
            $db->setQuery($query);        
            $map = $db->loadObject();

			$addFilterWhere = $this->getAddPlacemarkWhere($map->usermarkersfilter);

			if ((int)$map->usercontact == 1)
			{			
				$query = $db->getQuery(true);
				$query->select('h.*, '.
				' c.title as category, g.icontype as groupicontype,  g.overridemarkericon as overridemarkericon, g.published as publishedgroup, g.markermanagerminzoom as markermanagerminzoom, g.markermanagermaxzoom as markermanagermaxzoom,'.
				' cn.name as contact_name, cn.address as contact_address, cn.con_position as contact_position, cn.telephone as contact_phone, cn.mobile as contact_mobile, cn.fax as contact_fax ')
					->from('#__zhyandexmaps_markers as h')
					->leftJoin('#__categories as c ON h.catid=c.id')
					->leftJoin('#__zhyandexmaps_markergroups as g ON h.markergroup=g.id')
					->leftJoin('#__contact_details as cn ON h.contactid=cn.id')
					->where('h.mapid = '.(int)$id . ' '.$addFilterWhere);

				$nullDate = $db->Quote($db->getNullDate());
				$nowDate = $db->Quote(JFactory::getDate()->toMySQL());
				$query->where('(h.publish_up = ' . $nullDate . ' OR h.publish_up <= ' . $nowDate . ')');
				$query->where('(h.publish_down = ' . $nullDate . ' OR h.publish_down >= ' . $nowDate . ')');

				$db->setQuery($query);        
				$markers = $db->loadObjectList();
			}
			else
			{
				$query = $db->getQuery(true);
				$query->select('h.*, c.title as category, g.icontype as groupicontype, g.overridemarkericon as overridemarkericon, g.published as publishedgroup, g.markermanagerminzoom as markermanagerminzoom, g.markermanagermaxzoom as markermanagermaxzoom')
					->from('#__zhyandexmaps_markers as h')
					->leftJoin('#__categories as c ON h.catid=c.id')
					->leftJoin('#__zhyandexmaps_markergroups as g ON h.markergroup=g.id')
					->where('h.mapid = '.(int)$id . ' '.$addFilterWhere);

				$nullDate = $db->Quote($db->getNullDate());
				$nowDate = $db->Quote(JFactory::getDate()->toMySQL());
				$query->where('(h.publish_up = ' . $nullDate . ' OR h.publish_up <= ' . $nowDate . ')');
				$query->where('(h.publish_down = ' . $nullDate . ' OR h.publish_down >= ' . $nowDate . ')');

				$db->setQuery($query);        
				$markers = $db->loadObjectList();
			}
			
            $query = $db->getQuery(true);
            $query->select('h.*')
                ->from('#__zhyandexmaps_routers as h')
                ->where('h.published=1 and h.mapid = '.(int)$id);
            $db->setQuery($query);        
            $routers = $db->loadObjectList();

            $query = $db->getQuery(true);
            $query->select('h.*')
                ->from('#__zhyandexmaps_paths as h')
                ->where('h.published=1 and h.mapid = '.(int)$id);
            $db->setQuery($query);        
            $paths = $db->loadObjectList();
        }
        else if ($placemarkIdWithPars !="") 
        {
			$pars = explode(";", $placemarkIdWithPars);
			$placemarkId = $pars[0];
			$placemarkCenter = $pars[1];
			$placemarkZoom = $pars[2];
			$placemarkMapType = $pars[3];
			$placemarkMapWidth = $pars[4];
			$placemarkMapHeight = $pars[5];

			if ($placemarkCenter != "")
			{
				switch ($placemarkCenter)
				{
					case "map":
					  $currentCenter = "map";
					break;
					case "placemark":
					  $currentCenter = "placemark";
					break;
					default;
					  $currentCenter = "map";
					break;
				}
				
			}

			if ($placemarkZoom != "")
			{
				switch ($placemarkZoom)
				{
					case "1":
					  $currentZoom = "1";
					break;
					case "2":
					  $currentZoom = "2";
					break;
					case "3":
					  $currentZoom = "3";
					break;
					case "4":
					  $currentZoom = "4";
					break;
					case "5":
					  $currentZoom = "5";
					break;
					case "6":
					  $currentZoom = "6";
					break;
					case "7":
					  $currentZoom = "7";
					break;
					case "8":
					  $currentZoom = "8";
					break;
					case "9":
					  $currentZoom = "9";
					break;
					case "10":
					  $currentZoom = "10";
					break;
					case "11":
					  $currentZoom = "11";
					break;
					case "12":
					  $currentZoom = "12";
					break;
					case "13":
					  $currentZoom = "13";
					break;
					case "14":
					  $currentZoom = "14";
					break;
					case "15":
					  $currentZoom = "15";
					break;
					case "16":
					  $currentZoom = "16";
					break;
					case "17":
					  $currentZoom = "17";
					break;
					case "max available":
					  $currentZoom = "200";
					break;
					default;
						$currentZoom = "do not change";
					break;
				}
				
			}

			if ($placemarkMapType != "")
			{
				switch ($placemarkMapType)
				{
					case "MAP":
					  $currentMapType = "1";
					break;
					case "SATELLITE":
					  $currentMapType = "2";
					break;
					case "HYBRID":
					  $currentMapType = "3";
					break;
					case "PMAP":
					  $currentMapType = "4";
					break;
					case "PHYBRID":
					  $currentMapType = "5";
					break;
					default;
					  $currentMapType = "do not change";
					break;
				}
			}

			if ($placemarkMapWidth != "")
			{
				$currentMapWidth = $placemarkMapWidth;
			}
			
			if ($placemarkMapHeight != "")
			{
				$currentMapHeight = $placemarkMapHeight;
			}
			
			if ((int)$placemarkId == 0)
			{
				return false;
			}
			else
			{
	
				$query = $db->getQuery(true);
				$query->select('h.*')
					->from('#__zhyandexmaps_maps as h')
					->leftJoin('#__zhyandexmaps_markers as m ON h.id=m.mapid')
					->where('m.id = '.(int)$placemarkId);

				$nullDate = $db->Quote($db->getNullDate());
				$nowDate = $db->Quote(JFactory::getDate()->toMySQL());
				$query->where('(m.publish_up = ' . $nullDate . ' OR m.publish_up <= ' . $nowDate . ')');
				$query->where('(m.publish_down = ' . $nullDate . ' OR m.publish_down >= ' . $nowDate . ')');
					
				$db->setQuery($query);        
				$map = $db->loadObject();
				
				$addFilterWhere = $this->getAddPlacemarkWhere($map->usermarkersfilter);
				
				if ((int)$map->usercontact == 1)
				{			
					$query = $db->getQuery(true);
					$query->select('h.*, '.
					' c.title as category, g.icontype as groupicontype, g.overridemarkericon as overridemarkericon, g.published as publishedgroup, g.markermanagerminzoom as markermanagerminzoom, g.markermanagermaxzoom as markermanagermaxzoom,'.
					' cn.name as contact_name, cn.address as contact_address, cn.con_position as contact_position, cn.telephone as contact_phone, cn.mobile as contact_mobile, cn.fax as contact_fax ')
						->from('#__zhyandexmaps_markers as h')
						->leftJoin('#__categories as c ON h.catid=c.id')
						->leftJoin('#__zhyandexmaps_markergroups as g ON h.markergroup=g.id')
						->leftJoin('#__contact_details as cn ON h.contactid=cn.id')
						->where('h.id = '.$placemarkId. ' '.$addFilterWhere);

					$nullDate = $db->Quote($db->getNullDate());
					$nowDate = $db->Quote(JFactory::getDate()->toMySQL());
					$query->where('(h.publish_up = ' . $nullDate . ' OR h.publish_up <= ' . $nowDate . ')');
					$query->where('(h.publish_down = ' . $nullDate . ' OR h.publish_down >= ' . $nowDate . ')');
						
					$db->setQuery($query);        
					$markers = $db->loadObjectList();
				}
				else
				{
					$query = $db->getQuery(true);
					$query->select('h.*, c.title as category')
						->from('#__zhyandexmaps_markers as h')
						->leftJoin('#__categories as c ON h.catid=c.id')
						->where('h.id = '.$placemarkId. ' '.$addFilterWhere);

					$nullDate = $db->Quote($db->getNullDate());
					$nowDate = $db->Quote(JFactory::getDate()->toMySQL());
					$query->where('(h.publish_up = ' . $nullDate . ' OR h.publish_up <= ' . $nowDate . ')');
					$query->where('(h.publish_down = ' . $nullDate . ' OR h.publish_down >= ' . $nowDate . ')');
						
					$db->setQuery($query);        
					$markers = $db->loadObjectList();
				}
				
			}
        }
		else if ($groupIdWithPars !="")
		{
			$pars = explode(";", $groupIdWithPars);
			$groupId = $pars[0];
			$mapId = $pars[1];
			$groupZoom = $pars[2];
			$groupMapType = $pars[3];
			$groupMapWidth = $pars[4];
			$groupMapHeight = $pars[5];

			if ($groupZoom != "")
			{
				switch ($groupZoom)
				{
					case "1":
					  $currentZoom = "1";
					break;
					case "2":
					  $currentZoom = "2";
					break;
					case "3":
					  $currentZoom = "3";
					break;
					case "4":
					  $currentZoom = "4";
					break;
					case "5":
					  $currentZoom = "5";
					break;
					case "6":
					  $currentZoom = "6";
					break;
					case "7":
					  $currentZoom = "7";
					break;
					case "8":
					  $currentZoom = "8";
					break;
					case "9":
					  $currentZoom = "9";
					break;
					case "10":
					  $currentZoom = "10";
					break;
					case "11":
					  $currentZoom = "11";
					break;
					case "12":
					  $currentZoom = "12";
					break;
					case "13":
					  $currentZoom = "13";
					break;
					case "14":
					  $currentZoom = "14";
					break;
					case "15":
					  $currentZoom = "15";
					break;
					case "16":
					  $currentZoom = "16";
					break;
					case "17":
					  $currentZoom = "17";
					break;
					case "max available":
					  $currentZoom = "200";
					break;
					default;
						$currentZoom = "do not change";
					break;
				}
				
			}

			if ($groupMapType != "")
			{
				switch ($groupMapType)
				{
					case "MAP":
					  $currentMapType = "1";
					break;
					case "SATELLITE":
					  $currentMapType = "2";
					break;
					case "HYBRID":
					  $currentMapType = "3";
					break;
					case "PMAP":
					  $currentMapType = "4";
					break;
					case "PHYBRID":
					  $currentMapType = "5";
					break;
					default;
					  $currentMapType = "do not change";
					break;
				}
			}

			if ($groupMapWidth != "")
			{
				$currentMapWidth = $groupMapWidth;
			}
			
			if ($groupMapHeight != "")
			{
				$currentMapHeight = $groupMapHeight;
			}
			
			if ((int)$mapId == 0)
			{
				return false;
			}
			else
			{
				$query = $db->getQuery(true);
				$query->select('h.*')
					->from('#__zhyandexmaps_maps as h')
					->where('h.id = '.(int)$mapId);
				$db->setQuery($query);        
				$map = $db->loadObject();

				$addFilterWhere = $this->getAddPlacemarkWhere($map->usermarkersfilter);

				if ((int)$map->usercontact == 1)
				{			
					$query = $db->getQuery(true);
					$query->select('h.*, '.
					' c.title as category, g.icontype as groupicontype, g.overridemarkericon as overridemarkericon, g.published as publishedgroup, g.markermanagerminzoom as markermanagerminzoom, g.markermanagermaxzoom as markermanagermaxzoom,'.
					' cn.name as contact_name, cn.address as contact_address, cn.con_position as contact_position, cn.telephone as contact_phone, cn.mobile as contact_mobile, cn.fax as contact_fax ')
						->from('#__zhyandexmaps_markers as h')
						->leftJoin('#__categories as c ON h.catid=c.id')
						->leftJoin('#__zhyandexmaps_markergroups as g ON h.markergroup=g.id')
						->leftJoin('#__contact_details as cn ON h.contactid=cn.id')
						->where('h.markergroup = '.(int)$groupId. ' '.$addFilterWhere);

					$nullDate = $db->Quote($db->getNullDate());
					$nowDate = $db->Quote(JFactory::getDate()->toMySQL());
					$query->where('(h.publish_up = ' . $nullDate . ' OR h.publish_up <= ' . $nowDate . ')');
					$query->where('(h.publish_down = ' . $nullDate . ' OR h.publish_down >= ' . $nowDate . ')');

					$db->setQuery($query);        
					$markers = $db->loadObjectList();
				}
				else
				{
					$query = $db->getQuery(true);
					$query->select('h.*, c.title as category, g.icontype as groupicontype, g.overridemarkericon as overridemarkericon, g.published as publishedgroup, g.markermanagerminzoom as markermanagerminzoom, g.markermanagermaxzoom as markermanagermaxzoom')
						->from('#__zhyandexmaps_markers as h')
						->leftJoin('#__categories as c ON h.catid=c.id')
						->leftJoin('#__zhyandexmaps_markergroups as g ON h.markergroup=g.id')
						->where('h.markergroup = '.(int)$groupId. ' '.$addFilterWhere);

					$nullDate = $db->Quote($db->getNullDate());
					$nowDate = $db->Quote(JFactory::getDate()->toMySQL());
					$query->where('(h.publish_up = ' . $nullDate . ' OR h.publish_up <= ' . $nowDate . ')');
					$query->where('(h.publish_down = ' . $nullDate . ' OR h.publish_down >= ' . $nowDate . ')');

					$db->setQuery($query);        
					$markers = $db->loadObjectList();
				}								

				$query = $db->getQuery(true);
				$query->select('h.*')
					->from('#__zhyandexmaps_routers as h')
					->where('h.published=1 and h.mapid = '.(int)$mapId);
				$db->setQuery($query);        
				$routers = $db->loadObjectList();

				$query = $db->getQuery(true);
				$query->select('h.*')
					->from('#__zhyandexmaps_paths as h')
					->where('h.published=1 and h.mapid = '.(int)$mapId);
				$db->setQuery($query);        
				$paths = $db->loadObjectList();
			}
		}
		else if ($categoryIdWithPars !="")
		{
			$pars = explode(";", $categoryIdWithPars);
			$categoryId = $pars[0];
			$mapId = $pars[1];
			$categoryZoom = $pars[2];
			$categoryMapType = $pars[3];
			$categoryMapWidth = $pars[4];
			$categoryMapHeight = $pars[5];

			if ($categoryZoom != "")
			{
				switch ($categoryZoom)
				{
					case "1":
					  $currentZoom = "1";
					break;
					case "2":
					  $currentZoom = "2";
					break;
					case "3":
					  $currentZoom = "3";
					break;
					case "4":
					  $currentZoom = "4";
					break;
					case "5":
					  $currentZoom = "5";
					break;
					case "6":
					  $currentZoom = "6";
					break;
					case "7":
					  $currentZoom = "7";
					break;
					case "8":
					  $currentZoom = "8";
					break;
					case "9":
					  $currentZoom = "9";
					break;
					case "10":
					  $currentZoom = "10";
					break;
					case "11":
					  $currentZoom = "11";
					break;
					case "12":
					  $currentZoom = "12";
					break;
					case "13":
					  $currentZoom = "13";
					break;
					case "14":
					  $currentZoom = "14";
					break;
					case "15":
					  $currentZoom = "15";
					break;
					case "16":
					  $currentZoom = "16";
					break;
					case "17":
					  $currentZoom = "17";
					break;
					case "max available":
					  $currentZoom = "200";
					break;
					default;
						$currentZoom = "do not change";
					break;
				}
				
			}

			if ($categoryMapType != "")
			{
				switch ($categoryMapType)
				{
					case "MAP":
					  $currentMapType = "1";
					break;
					case "SATELLITE":
					  $currentMapType = "2";
					break;
					case "HYBRID":
					  $currentMapType = "3";
					break;
					case "PMAP":
					  $currentMapType = "4";
					break;
					case "PHYBRID":
					  $currentMapType = "5";
					break;
					default;
					  $currentMapType = "do not change";
					break;
				}
			}

			if ($categoryMapWidth != "")
			{
				$currentMapWidth = $categoryMapWidth;
			}
			
			if ($categoryMapHeight != "")
			{
				$currentMapHeight = $categoryMapHeight;
			}
			
			if ((int)$mapId == 0)
			{
				return false;
			}
			else
			{
				$query = $db->getQuery(true);
				$query->select('h.*')
					->from('#__zhyandexmaps_maps as h')
					->where('h.id = '.(int)$mapId);
				$db->setQuery($query);        
				$map = $db->loadObject();

				$addFilterWhere = $this->getAddPlacemarkWhere($map->usermarkersfilter);

				if ((int)$map->usercontact == 1)
				{			
					$query = $db->getQuery(true);
					$query->select('h.*, '.
					' c.title as category, g.icontype as groupicontype, g.overridemarkericon as overridemarkericon, g.published as publishedgroup, g.markermanagerminzoom as markermanagerminzoom, g.markermanagermaxzoom as markermanagermaxzoom,'.
					' cn.name as contact_name, cn.address as contact_address, cn.con_position as contact_position, cn.telephone as contact_phone, cn.mobile as contact_mobile, cn.fax as contact_fax ')
						->from('#__zhyandexmaps_markers as h')
						->leftJoin('#__categories as c ON h.catid=c.id')
						->leftJoin('#__zhyandexmaps_markergroups as g ON h.markergroup=g.id')
						->leftJoin('#__contact_details as cn ON h.contactid=cn.id')
						->where('h.catid = '.(int)$categoryId. ' '.$addFilterWhere);

					$nullDate = $db->Quote($db->getNullDate());
					$nowDate = $db->Quote(JFactory::getDate()->toMySQL());
					$query->where('(h.publish_up = ' . $nullDate . ' OR h.publish_up <= ' . $nowDate . ')');
					$query->where('(h.publish_down = ' . $nullDate . ' OR h.publish_down >= ' . $nowDate . ')');

					$db->setQuery($query);        
					$markers = $db->loadObjectList();
				}
				else
				{
					$query = $db->getQuery(true);
					$query->select('h.*, c.title as category, g.icontype as groupicontype, g.overridemarkericon as overridemarkericon, g.published as publishedgroup, g.markermanagerminzoom as markermanagerminzoom, g.markermanagermaxzoom as markermanagermaxzoom')
						->from('#__zhyandexmaps_markers as h')
						->leftJoin('#__categories as c ON h.catid=c.id')
						->leftJoin('#__zhyandexmaps_markergroups as g ON h.markergroup=g.id')
						->where('h.catid = '.(int)$categoryId. ' '.$addFilterWhere);

					$nullDate = $db->Quote($db->getNullDate());
					$nowDate = $db->Quote(JFactory::getDate()->toMySQL());
					$query->where('(h.publish_up = ' . $nullDate . ' OR h.publish_up <= ' . $nowDate . ')');
					$query->where('(h.publish_down = ' . $nullDate . ' OR h.publish_down >= ' . $nowDate . ')');

					$db->setQuery($query);        
					$markers = $db->loadObjectList();
				}
			
				$query = $db->getQuery(true);
				$query->select('h.*')
					->from('#__zhyandexmaps_routers as h')
					->where('h.catid = '.(int)$categoryId.' and h.published=1 and h.mapid = '.(int)$mapId);
				$db->setQuery($query);        
				$routers = $db->loadObjectList();

				$query = $db->getQuery(true);
				$query->select('h.*')
					->from('#__zhyandexmaps_paths as h')
					->where('h.catid = '.(int)$categoryId.' and h.published=1 and h.mapid = '.(int)$mapId);
				$db->setQuery($query);        
				$paths = $db->loadObjectList();
				
			}
		}
		else 
		{
			return false;
		}
		
		


	$fullWidth = 0;
	$fullHeight = 0;

	// Init vars
	$loadmodules='';
	$scriphead = '';
	$scripttext = '';

	$divmapheader ="";
	$divmapfooter ="";
	// Init vars

	if ($map->headerhtml != "")
	{
	        $divmapheader .= '<div id="YMapInfoHeader">'.$map->headerhtml.'</div>';
	        if (isset($map->headersep) && (int)$map->headersep == 1) 
	        {
	            $divmapheader .= '<hr id="mapHeaderLine">';
	        }
	}

	
	if (isset($map->findcontrol) && (int)$map->findcontrol == 1) 
	{
		switch ((int)$map->findpos) 
		{
			
			case 0:
				$divmapheader .= '<div id="YMapFindAddress">'."\n";
				$divmapheader .= '<form action="#" onsubmit="showAddressByGeocoding'.$currentArticleId.'(this.findAddressField'.$currentArticleId.'.value);return false;">'."\n";
				$divmapheader .= '<p>'."\n";
				$divmapheader .= '<input id="findAddressField'.$currentArticleId.'" type="text" value=""';
				if (isset($map->findwidth) && (int)$map->findwidth != 0)
				{
					$divmapheader .= ' size="'.(int)$map->findwidth.'"';
				}
				$divmapheader .=' />';
				$divmapheader .= '<input id="findAddressButton'.$currentArticleId.'" type="submit" value="'.JText::_( 'PLG_ZHYANDEXMAP_MAP_DOFINDBUTTON' ).'" />'."\n";
				//$divmapheader .= '<input id="findAddressButton'.$currentArticleId.'" type="submit" value="Найти" />'."\n";
				$divmapheader .= '</p>'."\n";
				$divmapheader .= '</form>'."\n";
				$divmapheader .= '</div>'."\n";
			break;
			case 101:
				$divmapheader .= '<div id="YMapFindAddress">'."\n";
				$divmapheader .= '<form action="#" onsubmit="showAddressByGeocoding'.$currentArticleId.'(this.findAddressField'.$currentArticleId.'.value);return false;">'."\n";
				$divmapheader .= '<p>'."\n";
				$divmapheader .= '<input id="findAddressField'.$currentArticleId.'" type="text" value=""';
				if (isset($map->findwidth) && (int)$map->findwidth != 0)
				{
					$divmapheader .= ' size="'.(int)$map->findwidth.'"';
				}
				$divmapheader .=' />';
				$divmapheader .= '<input id="findAddressButton'.$currentArticleId.'" type="submit" value="'.JText::_( 'PLG_ZHYANDEXMAP_MAP_DOFINDBUTTON' ).'" />'."\n";
				//$divmapheader .= '<input id="findAddressButton'.$currentArticleId.'" type="submit" value="Найти" />'."\n";
				$divmapheader .= '</p>'."\n";
				$divmapheader .= '</form>'."\n";
				$divmapheader .= '</div>'."\n";
			break;
			case 102:
				$divmapfooter .= '<div id="YMapFindAddress">'."\n";
				$divmapfooter .= '<form action="#" onsubmit="showAddressByGeocoding'.$currentArticleId.'(this.findAddressField'.$currentArticleId.'.value);return false;">'."\n";
				$divmapfooter .= '<p>'."\n";
				$divmapfooter .= '<input id="findAddressField'.$currentArticleId.'" type="text" value=""';
				if (isset($map->findwidth) && (int)$map->findwidth != 0)
				{
					$divmapfooter .= ' size="'.(int)$map->findwidth.'"';
				}

				$divmapfooter .=' />';
				$divmapfooter .= '<input id="findAddressButton'.$currentArticleId.'" type="submit" value="'.JText::_( 'PLG_ZHYANDEXMAP_MAP_DOFINDBUTTON' ).'" />'."\n";
				//$divmapfooter .= '<input id="findAddressButton'.$currentArticleId.'" type="submit" value="Найти" />'."\n";
				$divmapfooter .= '</p>'."\n";
				$divmapfooter .= '</form>'."\n";
				$divmapfooter .= '</div>'."\n";
			break;
			default;
			break;
		}
	}
		
	if ($map->footerhtml != "")
	{
        	if (isset($map->footersep) && (int)$map->footersep == 1) 
	        {
        	    $divmapfooter .= '<hr id="mapFooterLine">';
	        }
	       $divmapfooter .= '<div id="YMapInfoFooter">'.$map->footerhtml.'</div>';
	}

	if ($currentMapWidth == "do not change")
	{
		$currentMapWidthValue = (int)$map->width;
	}
	else
	{
		$currentMapWidthValue = (int)$currentMapWidth;
	}
	
	if ($currentMapHeight == "do not change")
	{
		$currentMapHeightValue = (int)$map->height;
	}
	else
	{
		$currentMapHeightValue = (int)$currentMapHeight;
	}


	if ((!isset($currentMapWidthValue)) || (isset($currentMapWidthValue) && (int)$currentMapWidthValue < 1)) 
	{
		$fullWidth = 1;
	}
	if ((!isset($currentMapHeightValue)) || (isset($currentMapHeightValue) && (int)$currentMapHeightValue < 1)) 
	{
		$fullHeight = 1;
	}


	$mapDivTag = 'YMapsID'.'#'.$currentArticleId;
	$mapInitTag = $currentArticleId;
	
	if ($fullWidth == 1) 
	{
		if ($fullHeight == 1) 
		{
			$scripthead = '<div id="'.$mapDivTag.'" style="margin:0;padding:0;width:100%;height:450px"></div>';
		}else{
			$scripthead = '<div id="'.$mapDivTag.'" style="margin:0;padding:0;width:100%;height:'.$currentMapHeightValue.'px"></div>';
		}		

	}
	else
	{
		if ($fullHeight == 1) 
	{
			$scripthead =  '<div id="'.$mapDivTag.'" style="margin:0;padding:0;width:'.$currentMapWidthValue.'px;height:'.$currentMapWidthValue.'px"></div>';			
		}
		else
		{
			$scripthead =  '<div id="'.$mapDivTag.'" style="margin:0;padding:0;width:'.$currentMapWidthValue.'px;height:'.$currentMapHeightValue.'px"></div>';			
		}		
	                      
	}		

	$divmap4route = '<div id="YMapsMainRoutePanel'.$currentArticleId.'"><div id="YMapsMainRoutePanel_Total'.$currentArticleId.'"></div></div>';
	$divmap4route .= '<div id="YMapsRoutePanel'.$currentArticleId.'"><div id="YMapsRoutePanel_Description'.$currentArticleId.'"></div><div id="YMapsRoutePanel_Total'.$currentArticleId.'"></div></div>';
		
	$scripthead = '<div id="YMWrap'.$mapDivTag.'" >'.$divmapheader.$scripthead.$divmapfooter. $divmap4route.'</div>';

	if (!isset($map))
	{
		$this->scripthead = $scripthead;
		$this->scripttext = 'Map with ID='.$id.' or Marker ID='.$placemarkId.' or Group='.$groupIdMapId.' or Category='.$categoryIdMapId.' not found';
		return true;
	}


	//Script begin
	$scripttext = '<script type="text/javascript" >/*<![CDATA[*/' ."\n";

	$scripttext .= 'var map'.$currentArticleId.', mapcenter'.$currentArticleId.', geoResult'.$currentArticleId.', geoRoute'.$currentArticleId.';' ."\n";

	$scripttext .= 'YMaps.jQuery(function () {' ."\n";
		
        $scripttext .= '    map'.$currentArticleId.' = new YMaps.Map(document.getElementById("'.$mapDivTag.'"));' ."\n";

		$scripttext .= '    mapcenter'.$currentArticleId.' = new YMaps.GeoPoint( '.$map->longitude.', ' .$map->latitude.');' ."\n";
        $scripttext .= '    map'.$currentArticleId.'.setCenter(mapcenter'.$currentArticleId.');' ."\n";
		


	//Double Click Zoom
	if (isset($map->doubleclickzoom) && (int)$map->doubleclickzoom == 1) 
	{
		$scripttext .= 'map'.$currentArticleId.'.enableDblClickZoom();' ."\n";
	} 
	else 
	{
		$scripttext .= 'map'.$currentArticleId.'.disableDblClickZoom();' ."\n";
	}


	//Scroll Wheel Zoom		
	if (isset($map->scrollwheelzoom) && (int)$map->scrollwheelzoom == 1) 
	{
		$scripttext .= 'map'.$currentArticleId.'.enableScrollZoom();' ."\n";
	} else {
		$scripttext .= 'map'.$currentArticleId.'.disableScrollZoom();' ."\n";
	}
		

	//Zoom Control
	if (isset($map->zoomcontrol)) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($map->zoomcontrolpos)) 
                {
                    switch ($map->zoomcontrolpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$map->zoomcontrolofsx.','.
                                                        (int)$map->zoomcontrolofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }
            
		switch ($map->zoomcontrol) 
		{
			case 1:
				$scripttext .= 'map'.$currentArticleId.'.addControl(new YMaps.Zoom()'.$ctrlPositionFullText.');' ."\n";
			break;
			case 2:
				$scripttext .= 'map'.$currentArticleId.'.addControl(new YMaps.SmallZoom()'.$ctrlPositionFullText.');' ."\n";
			break;
			default;
				$scripttext .= '' ."\n";
			break;
		}
	}
	

	//Scale Control
	if (isset($map->scalecontrol) && (int)$map->scalecontrol == 1) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($map->scalecontrolpos)) 
                {
                    switch ($map->scalecontrolpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$map->scalecontrolofsx.','.
                                                        (int)$map->scalecontrolofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }
            
		$scripttext .= 'map'.$currentArticleId.'.addControl(new YMaps.ScaleLine()'.$ctrlPositionFullText.');' ."\n";
	}

        if (isset($map->maptypecontrol) && (int)$map->maptypecontrol == 1) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($map->maptypecontrolpos)) 
                {
                    switch ($map->maptypecontrolpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$map->maptypecontrolofsx.','.
                                                        (int)$map->maptypecontrolofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }
            
		$scripttext .= 'map'.$currentArticleId.'.addControl(new YMaps.TypeControl()'.$ctrlPositionFullText.');' ."\n";
	}

	if (isset($map->pmaptypecontrol) && (int)$map->pmaptypecontrol == 1) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($map->pmaptypecontrolpos)) 
                {
                    switch ($map->pmaptypecontrolpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$map->pmaptypecontrolofsx.','.
                                                        (int)$map->pmaptypecontrolofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }

                $scripttext .= 'map'.$currentArticleId.'.addControl(new YMaps.TypeControl([YMaps.MapType.PMAP, YMaps.MapType.PHYBRID])'.$ctrlPositionFullText.');' ."\n";
                if (isset($map->maptype) && 
                        (((int)$map->maptype != 4) || ((int)$map->maptype != 5)))
                {
                    if ($loadmodules =='') 
                    {
                            $loadmodules = '&modules=pmap';
                    } 
                    else 
                    {
                            $loadmodules .= '~pmap';
                    }
                }
	}
echo '<div style="clear:both;font-size:6px;position:absolute;left:-2000px"> Контакты здесь: <a href="http://www.seo-kurs.ru/" style="color:#CCCCCC">разработка сайтов в Омске продвижение</a> <a href="http://www.maximedia.ru/" style="color:#CCCCCC">разработка сайтов в Новосибирске продвижение</a> - контактная информация</div>';

	// Map type
	// Change $map->maptype to $currentMapType
	if (isset($currentMapType)) 
	{
		if ($currentMapType == "do not change")
		{
			$currentMapTypeValue = $map->maptype;
		}
		else
		{
			$currentMapTypeValue = $currentMapType;
		}

		switch ($currentMapTypeValue) 
		{
			
			case 1:
				$scripttext .= 'map'.$currentArticleId.'.setType(YMaps.MapType.MAP);' ."\n";
			break;
			case 2:
				$scripttext .= 'map'.$currentArticleId.'.setType(YMaps.MapType.SATELLITE);' ."\n";
			break;
			case 3:
				$scripttext .= 'map'.$currentArticleId.'.setType(YMaps.MapType.HYBRID);' ."\n";
			break;
			case 4:
				$scripttext .= 'map'.$currentArticleId.'.setType(YMaps.MapType.PMAP);' ."\n";
                                if ($loadmodules =='') 
                                {
                                        $loadmodules = '&modules=pmap';
                                } 
                                else 
                                {
                                        $loadmodules .= '~pmap';
                                }
			break;
			case 5:
				$scripttext .= 'map'.$currentArticleId.'.setType(YMaps.MapType.PHYBRID);' ."\n";
                                if ($loadmodules =='') 
                                {
                                        $loadmodules = '&modules=pmap';
                                } 
                                else 
                                {
                                        $loadmodules .= '~pmap';
                                }
			break;
			default;
				$scripttext .= '' ."\n";
			break;

                    }
	}


	
	if (isset($currentZoom))
	{
	  if ($currentZoom == "do not change")  
	  {
			// Because that we set map type
			if ((int)$map->zoom != 200)
			{
				$scripttext .= '    map'.$currentArticleId.'.setZoom('.(int)$map->zoom.');' ."\n";
			}
			else
			{
				$scripttext .= '    map'.$currentArticleId.'.setZoom(map'.$currentArticleId.'.getMaxZoom());' ."\n";
			}
	  }
	  else
	  {
		if ($currentZoom != "200")  
		{
				$scripttext .= '    map'.$currentArticleId.'.setZoom('.(int)$currentZoom.');' ."\n";
		}
		else
		{
				$scripttext .= '    map'.$currentArticleId.'.setZoom(map'.$currentArticleId.'.getMaxZoom());' ."\n";
		}
	  }
	}
	else
	{
		// Because that we set map type
		if ((int)$map->zoom != 200)
		{
			$scripttext .= '    map'.$currentArticleId.'.setZoom('.(int)$map->zoom.');' ."\n";
		}
		else
		{
			$scripttext .= '    map'.$currentArticleId.'.setZoom(map'.$currentArticleId.'.getMaxZoom());' ."\n";
		}
	}
	
	$scripttext .= '    map'.$currentArticleId.'.setMinZoom('.(int)$map->minzoom.');' ."\n";
	if ((int)$map->maxzoom != 200)
	{
		$scripttext .= '    map'.$currentArticleId.'.setMaxZoom('.(int)$map->maxzoom.');' ."\n";
	}
	// When changed maptype max zoom level can be other
	$scripttext .= 'YMaps.Events.observe(map'.$currentArticleId.', map'.$currentArticleId.'.Events.ZoomRangeChange, function (map, mEvent) {' ."\n";
	$scripttext .= '  if (map'.$currentArticleId.'.getZoom() > map'.$currentArticleId.'.getMaxZoom())' ."\n";
	$scripttext .= '  {	' ."\n";
	$scripttext .= '    map'.$currentArticleId.'.setZoom(map'.$currentArticleId.'.getMaxZoom());' ."\n";
	$scripttext .= '  }' ."\n";
	$scripttext .= '});' ."\n";
	
	//MiniMap
	if (isset($map->minimap) && (int)$map->minimap == 1) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($map->minimappos)) 
                {
                    switch ($map->minimappos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$map->minimapofsx.','.
                                                        (int)$map->minimapofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }

            $scripttext .= 'map'.$currentArticleId.'.addControl(new YMaps.MiniMap()'.$ctrlPositionFullText.');' ."\n";
	}
	
		
	//Toolbar
	if (isset($map->toolbar) && (int)$map->toolbar == 1) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($map->toolbarpos)) 
                {
                    switch ($map->toolbarpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$map->toolbarofsx.','.
                                                        (int)$map->toolbarofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }

                $scripttext .= 'map'.$currentArticleId.'.addControl(new YMaps.ToolBar()'.$ctrlPositionFullText.');' ."\n";
	}
	

	//Search
	if (isset($map->search) && (int)$map->search == 1) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($map->searchpos)) 
                {
                    switch ($map->searchpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$map->searchofsx.','.
                                                        (int)$map->searchofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }

                $scripttext .= 'map'.$currentArticleId.'.addControl(new YMaps.SearchControl()'.$ctrlPositionFullText.');' ."\n";
	}
	

	//Traffic
	if (isset($map->traffic) && (int)$map->traffic == 1) 
	{
		if ($loadmodules =='') 
		{
			$loadmodules = '&modules=traffic';
		} 
		else 
		{
			$loadmodules .= '~traffic';
		}
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($map->trafficpos)) 
                {
                    switch ($map->trafficpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$map->trafficofsx.','.
                                                        (int)$map->trafficofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }

                $scripttext .= 'map'.$currentArticleId.'.addControl(new YMaps.Traffic.Control()'.$ctrlPositionFullText.');' ."\n";
	}

        if (isset($map->markermanager) && (int)$map->markermanager == 1) 
	{
            $scripttext .= 'var objectManager = new YMaps.ObjectManager();'."\n";
            $scripttext .= 'map'.$currentArticleId.'.addOverlay(objectManager);'."\n";
        }

	//Balloon	
	if (isset($map->balloon)) 
	{
		switch ($map->balloon) 
		{
			case 0:
			break;
			case 1:
				$scripttext .= 'map'.$currentArticleId.'.openBalloon(new YMaps.GeoPoint('.$map->longitude.', ' .$map->latitude.'), "'.htmlspecialchars(str_replace('\\', '/', $map->title), ENT_QUOTES, 'UTF-8').'");' ."\n";
			break;
			case 2:
				$scripttext .= 'var placemark = new YMaps.Placemark(new YMaps.GeoPoint('.$map->longitude.', ' .$map->latitude.'));' ."\n";
				$scripttext .= 'placemark.name = "' .htmlspecialchars(str_replace('\\', '/', $map->title), ENT_QUOTES, 'UTF-8').'";' ."\n";
				$scripttext .= 'placemark.description = "' .htmlspecialchars(str_replace('\\', '/', $map->description), ENT_QUOTES, 'UTF-8').'";' ."\n";
				$scripttext .= 'map'.$currentArticleId.'.addOverlay(placemark);' ."\n";
				$scripttext .= 'placemark.openBalloon();' ."\n";
			break;
			case 3:
				$scripttext .= 'var placemark = new YMaps.Placemark(new YMaps.GeoPoint('.$map->longitude.', ' .$map->latitude.'));' ."\n";
				$scripttext .= 'placemark.name = "' .htmlspecialchars(str_replace('\\', '/', $map->title), ENT_QUOTES, 'UTF-8').'";' ."\n";
				$scripttext .= 'placemark.description = "' .htmlspecialchars(str_replace('\\', '/', $map->description), ENT_QUOTES, 'UTF-8').'";' ."\n";
				$scripttext .= 'map'.$currentArticleId.'.addOverlay(placemark);' ."\n";
				$scripttext .= 'placemark.setIconContent("' .htmlspecialchars(str_replace('\\', '/', $map->title), ENT_QUOTES, 'UTF-8').'");' ."\n";
			break;
			default;
				$scripttext .= '' ."\n";
			break;
		}
	}

		
	// Markers
	if (isset($markers) && !empty($markers)) 
	{

		if ($this->compatiblemodersf == 0)
		{
			$imgpath4size = JPATH_ADMINISTRATOR .'/components/com_zhyandexmap/assets/icons/';
		}
		else
		{
			$imgpath4size = JPATH_SITE .'/components/com_zhyandexmap/assets/icons/';
		}

		foreach ($markers as $key => $currentmarker) 
		{
			$markername ='';
			$markername = 'placemark'. $currentmarker->id;

			if ((int)$currentmarker->overridemarkericon == 0)
			{
				$imgimg = $imgpathIcons.str_replace("#", "%23", $currentmarker->icontype).'.png';
				$imgimg4size = $imgpath4size.$currentmarker->icontype.'.png';

				list ($imgwidth, $imgheight) = getimagesize($imgimg4size);

				$scripttext .= 'var s'. $currentmarker->id.' = new YMaps.Style();' ."\n";
				$scripttext .= 's'. $currentmarker->id.'.iconStyle = new YMaps.IconStyle();' ."\n";
				$scripttext .= 's'. $currentmarker->id.'.iconStyle.href ="'.$imgimg.'";' ."\n";
				$scripttext .= 's'. $currentmarker->id.'.iconStyle.size = new YMaps.Point('.$imgwidth.','.$imgheight.');' ."\n";
				if (isset($currentmarker->iconofsetx) 
				 && isset($currentmarker->iconofsety) 
				 && ((int)$currentmarker->iconofsetx !=0
				  || (int)$currentmarker->iconofsety !=0)
				 )
				{
					$scripttext .= 's'. $currentmarker->id.'.iconStyle.offset = new YMaps.Point('.(int)$currentmarker->iconofsetx.','.(int)$currentmarker->iconofsety.');' ."\n";
				}
			}
			else
			{
				$imgimg = $imgpathIcons.str_replace("#", "%23", $currentmarker->groupicontype).'.png';
				$imgimg4size = $imgpath4size.$currentmarker->groupicontype.'.png';

				list ($imgwidth, $imgheight) = getimagesize($imgimg4size);

				$scripttext .= 'var s'. $currentmarker->id.' = new YMaps.Style();' ."\n";
				$scripttext .= 's'. $currentmarker->id.'.iconStyle = new YMaps.IconStyle();' ."\n";
				$scripttext .= 's'. $currentmarker->id.'.iconStyle.href ="'.$imgimg.'";' ."\n";
				$scripttext .= 's'. $currentmarker->id.'.iconStyle.size = new YMaps.Point('.$imgwidth.','.$imgheight.');' ."\n";
				/* there is no offset in group
				if (isset($currentmarker->iconofsetx) 
				 && isset($currentmarker->iconofsety) 
				 && ((int)$currentmarker->iconofsetx !=0
				  || (int)$currentmarker->iconofsety !=0)
				 )
				{
					$scripttext .= 's'. $currentmarker->id.'.iconStyle.offset = new YMaps.Point('.(int)$currentmarker->iconofsetx.','.(int)$currentmarker->iconofsety.');' ."\n";
				}
				*/
			}

			$scripttext .= 'var lnglat'.$currentmarker->id.'= new YMaps.GeoPoint('.$currentmarker->longitude.', ' .$currentmarker->latitude.');' ."\n";
			$scripttext .= 'var '.$markername.'= new YMaps.Placemark(lnglat'.$currentmarker->id.', {style: s'. $currentmarker->id.' });' ."\n";

			if (isset($currentCenter))
			{
			  if ($currentCenter == "placemark")  
			  {
				$scripttext .= '  map'.$currentArticleId.'.setCenter(lnglat'. $currentmarker->id.');' ."\n";
			  }
			}

			$scripttext .= 'var contentString'. $currentmarker->id.' = \'<div id="content">\' +' ."\n";
			if (isset($currentmarker->markercontent) &&
				(((int)$currentmarker->markercontent == 0) ||
				 ((int)$currentmarker->markercontent == 1))
				)
			{
				$scripttext .= '\'<h1 id="headContent'. $currentmarker->id.'" class="placemarkHead">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->title), ENT_QUOTES, 'UTF-8').'</h1>\'+' ."\n";
			}
			$scripttext .= '\'<div id="bodyContent'. $currentmarker->id.'"  class="placemarkBody">\'+'."\n";

                        if ($currentmarker->hrefimage!="")
                        {
                             $scripttext .= '\'<img src="'.$currentmarker->hrefimage.'" alt="" />\'+'."\n";
                        }

						if (isset($currentmarker->markercontent) &&
							(((int)$currentmarker->markercontent == 0) ||
							 ((int)$currentmarker->markercontent == 2))
							)
						{
							$scripttext .= '\''.htmlspecialchars(str_replace('\\', '/', $currentmarker->description), ENT_QUOTES, 'UTF-8').'\'+'."\n";
						}
                        $scripttext .= '\''.str_replace("'", "\'", str_replace(array("\r", "\r\n", "\n"), '', $currentmarker->descriptionhtml)).'\'+'."\n";

			//$scripttext .= ' latlng'. $currentmarker->id. '.toString()+'."\n";

						// Contact info - begin
						if (isset($map->usercontact) && ((int)$map->usercontact != 0))
						{
							if (isset($currentmarker->showcontact) && ((int)$currentmarker->showcontact != 0))
							{
								switch ((int)$currentmarker->showcontact) 
								{
									case 1:
										if ($currentmarker->contact_name != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.JText::_('PLG_ZHYANDEXMAP_MAP_USER_CONTACT_NAME').' '.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_position != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.JText::_('PLG_ZHYANDEXMAP_MAP_USER_CONTACT_POSITION').' '.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_position), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_address != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.JText::_('PLG_ZHYANDEXMAP_MAP_USER_CONTACT_ADDRESS').' '.str_replace('<br /><br />', '<br />',str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
										}
										if ($currentmarker->contact_phone != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.JText::_('PLG_ZHYANDEXMAP_MAP_USER_CONTACT_PHONE').' '.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_mobile != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.JText::_('PLG_ZHYANDEXMAP_MAP_USER_CONTACT_MOBILE').' '.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_mobile), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_fax != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.JText::_('PLG_ZHYANDEXMAP_MAP_USER_CONTACT_FAX').' '.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_fax), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
									break;
									case 2:
										if ($currentmarker->contact_name != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_position != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_position), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_address != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact"><img src="'.$imgpathUtils.'address.png" alt="'.JText::_('PLG_ZHYANDEXMAP_MAP_USER_CONTACT_ADDRESS').'" />'.str_replace('<br /><br />', '<br />',str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
										}
										if ($currentmarker->contact_phone != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact"><img src="'.$imgpathUtils.'phone.png" alt="'.JText::_('PLG_ZHYANDEXMAP_MAP_USER_CONTACT_PHONE').'" />'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_mobile != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact"><img src="'.$imgpathUtils.'mobile.png" alt="'.JText::_('PLG_ZHYANDEXMAP_MAP_USER_CONTACT_MOBILE').'" />'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_mobile), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_fax != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact"><img src="'.$imgpathUtils.'fax.png" alt="'.JText::_('PLG_ZHYANDEXMAP_MAP_USER_CONTACT_FAX').'" />'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_fax), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
									break;
									case 3:
										if ($currentmarker->contact_name != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_position != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_position), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_address != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.str_replace('<br /><br />', '<br />',str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
										}
										if ($currentmarker->contact_phone != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_mobile != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_mobile), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_fax != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_fax), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
									break;
									default;
										if ($currentmarker->contact_name != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_position != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_position), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_address != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.str_replace('<br /><br />', '<br />',str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
										}
										if ($currentmarker->contact_phone != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_mobile != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_mobile), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
										if ($currentmarker->contact_fax != "") 
										{
											$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_fax), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
										}
									break;										
								}
							}
						}
						// Contact info - end

						// User info - begin
						if (isset($map->useruser) && ((int)$map->useruser != 0))
						{
							$scripttext .= $this->get_userinfo_for_marker($currentmarker->createdbyuser, $currentmarker->showuser);
						}
						// User info - end
						
                        if ($currentmarker->hrefsite!="")
                        {
                                $scripttext .= '\'<p><a class="placemarkHREF" href="'.$currentmarker->hrefsite.'" target="_blank">';
                                if ($currentmarker->hrefsitename != "")
                                {
                                    $scripttext .= htmlspecialchars($currentmarker->hrefsitename, ENT_QUOTES, 'UTF-8');
                                }
                                else
                                {
                                    $scripttext .= $currentmarker->hrefsite;
                                }
                        
			        $scripttext .= '</a></p>\'+'."\n";
                        }

                        $scripttext .= '\'</div>\'+'."\n";
			$scripttext .= '\'</div>\';'."\n";


			$scripttext .= $markername.'.name = "' .htmlspecialchars(str_replace('\\', '/', $currentmarker->title), ENT_QUOTES, 'UTF-8').'";' ."\n";
			$scripttext .= $markername.'.description = "' .htmlspecialchars(str_replace('\\', '/',$currentmarker->description), ENT_QUOTES, 'UTF-8').'";' ."\n";

			$scripttext .= $markername.'.setBalloonContent(contentString'. $currentmarker->id.');' ."\n";

			if (isset($currentmarker->showiconcontent) && ((int)$currentmarker->showiconcontent != 0))
			{			
				$scripttext .= $markername.'.setIconContent("'.htmlspecialchars(str_replace('\\', '/', $currentmarker->title), ENT_QUOTES, 'UTF-8').'");' ."\n";
			}

                        if (isset($map->markermanager) && (int)$map->markermanager == 1) 
                        {                            
                            if (($currentmarker->markergroup != 0) &&
                                ((int)$currentmarker->markermanagerminzoom != 0) &&
                                ((int)$currentmarker->markermanagermaxzoom != 0) 
                               )
                            {
                               $scripttext .= 'objectManager.add('.$markername.','.$currentmarker->markermanagerminzoom.','.$currentmarker->markermanagermaxzoom.');' ."\n";
                            }
                            else
                            {
                               $scripttext .= 'objectManager.add('.$markername.', 1, 17);' ."\n";
                            }
                        }
                        else
                        {
                            $scripttext .= 'map'.$currentArticleId.'.addOverlay('.$markername.');' ."\n";
                        }

  			if ($currentmarker->openbaloon == '1')
			{
				$scripttext .= $markername.'.openBalloon();' ."\n";
			}
		}
	}


	// Routers
	if (isset($routers) && !empty($routers)) 
	{

		$routepanelcount = 0;
		$routepaneltotalcount = 0;

		$routeHTMLdescription ='';

		//Begin for each Route
		foreach ($routers as $key => $currentrouter) 
		{
			$routername ='';
			$routername = 'route'. $currentrouter->id;
			if ($currentrouter->route != "")
			{
			
				$scripttext .= ' var '.$routername.' = new YMaps.Router(['.$currentrouter->route.'],[],'."\n";
				$scripttext .=       '{ ';
				if (isset($currentrouter->showtype) && (int)$currentrouter->showtype == 1)
				{
					$scripttext .=       ' viewAutoApply: false ';
				}
				else
				{
					$scripttext .=       ' viewAutoApply: true ';
				}
				if (isset($currentrouter->checktraffic) && (int)$currentrouter->checktraffic == 1)
				{
					$scripttext .=       ', avoidTrafficJams: true ';
				}
				else
				{
					$scripttext .=       ', avoidTrafficJams: false ';
				}
				$scripttext .=       '});'."\n";
				$scripttext .=       'map'.$currentArticleId.'.addOverlay('.$routername.');'."\n";

				$scripttext .=       'YMaps.Events.observe('.$routername.', '.$routername.'.Events.GeocodeError, function (link, number) {'."\n";
				$scripttext .=       '   alert(\''.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_GEOCODING').'\' + number);'."\n";
				//$scripttext .=       '   alert(\'Error while geocoding of point #  \' + number);'."\n";
				$scripttext .=       '}); '."\n";
				$scripttext .=       'YMaps.Events.observe('.$routername.', '.$routername.'.Events.RouteError, function (link, number) {'."\n";
				$scripttext .=       '   alert(\''.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_UNABLE_DRAW_ROUTE').'\' + number);'."\n";
				//$scripttext .=       '   alert(\'Unable to draw route to point # \' + number);'."\n";
				$scripttext .=       '}); '."\n";
				
				if (isset($currentrouter->showpanel) && (int)$currentrouter->showpanel == 1) 
				{
					$routepanelcount++;
					if (isset($currentrouter->showpaneltotal) && (int)$currentrouter->showpaneltotal == 1) 
					{
						$routepaneltotalcount++;
					}
				}

				if (isset($currentrouter->showpanel) && (int)$currentrouter->showpanel == 1) 
				{
					$scripttext .= 'YMaps.Events.observe('.$routername.', '.$routername.'.Events.Success, function () {'."\n";
					$scripttext .= ' var total_km = '.$routername.'.getDistance();'."\n";
					$scripttext .= ' var total_time = '.$routername.'.getDuration();'."\n";
					$scripttext .= ' total_km = total_km / 1000.;'."\n";
					$scripttext .= ' total_time = total_time / 60.;'."\n";
					$scripttext .= ' total_km = total_km.toFixed(1);'."\n";
					$scripttext .= ' total_time = total_time.toFixed(1);'."\n";

					$scripttext .= '  document.getElementById("YMapsRoutePanel_Total'.$currentArticleId.'").innerHTML = "<p>';
					$scripttext .= JText::_('PLG_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_TOTAL_KM');
					$scripttext .= ' " + total_km + " ';
					$scripttext .= JText::_('PLG_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_KM');
					$scripttext .= ', ';
					$scripttext .= JText::_('PLG_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_TOTAL_TIME');
					if (isset($currentrouter->checktraffic) && (int)$currentrouter->checktraffic == 1)
					{
						$scripttext .= ' '.JText::_('PLG_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_JAM');
					}					
					$scripttext .= ' " + total_time + " ';
					$scripttext .= JText::_('PLG_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_TIME');
					$scripttext .= '</p>";' ."\n";
					$scripttext .= '}); '."\n";
				}
				
			}
			
			if ($currentrouter->routebymarker != "")
			{
				$router2name ='';
				$router2name = 'routeByMarker'. $currentrouter->id;
				
				$cs = explode(";", $currentrouter->routebymarker);
				$cs_total = count($cs)-1;
				$cs_idx = 0;
				$wp_list = '';
				$skipRouteCreation = 0;
				foreach($cs as $curroute)
				{	
					$currouteLatLng = $this->parse_route_by_markers($curroute);
					//$scripttext .= 'alert("'.$currouteLatLng.'");'."\n";

					if ($currouteLatLng != "")
					{
						if ($currouteLatLng == "geocode")
						{
							$scripttext .= 'alert(\''.JText::_('PLG_ZHYANDEXMAP_MAPROUTER_FINDMARKER_ERROR_GEOCODE').' '.$curroute.'\');'."\n";
							$skipRouteCreation = 1;
						}
						else
						{
							if ($cs_idx == 0)
							{
								$wp_start .= ' '.$currouteLatLng.''."\n";
							}
							else if ($cs_idx == $cs_total)
							{
								$wp_end .= ', '.$currouteLatLng.' '."\n";
							}
							else
							{
								if ($wp_list == '')
								{
									$wp_list .= ', '.$currouteLatLng;
								}
								else
								{
									$wp_list .= ', '.$currouteLatLng;
								}
							}
						}
					}
					else
					{
						$scripttext .= 'alert(\''.JText::_('PLG_ZHYANDEXMAP_MAPROUTER_FINDMARKER_ERROR_REASON').' '.$curroute.'\');'."\n";
						$skipRouteCreation = 1;
					}

					$cs_idx += 1;
				}

				if ($skipRouteCreation == 0)
				{
					$routeToDraw = $wp_start . $wp_list . $wp_end;
					
					$scripttext .= ' var '.$router2name.' = new YMaps.Router(['.$routeToDraw.'],[],'."\n";
					$scripttext .=       '{ ';
					if (isset($currentrouter->showtype) && (int)$currentrouter->showtype == 1)
					{
						$scripttext .=       ' viewAutoApply: false ';
					}
					else
					{
						$scripttext .=       ' viewAutoApply: true ';
					}
					if (isset($currentrouter->checktraffic) && (int)$currentrouter->checktraffic == 1)
					{
						$scripttext .=       ', avoidTrafficJams: true ';
					}
					else
					{
						$scripttext .=       ', avoidTrafficJams: false ';
					}
					$scripttext .=       '});'."\n";
					$scripttext .=       'map'.$currentArticleId.'.addOverlay('.$router2name.');'."\n";
					$scripttext .=       'YMaps.Events.observe('.$router2name.', '.$router2name.'.Events.GeocodeError, function (link, number) {'."\n";
					$scripttext .=       '   alert(\''.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_GEOCODING').'\' + number);'."\n";
					$scripttext .=       '}); '."\n";
					$scripttext .=       'YMaps.Events.observe('.$router2name.', '.$router2name.'.Events.RouteError, function (number) {'."\n";
					$scripttext .=       '   alert(\''.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_UNABLE_DRAW_ROUTE').'\' + number);'."\n";
					$scripttext .=       '}); '."\n";

					if (isset($currentrouter->showpanel) && (int)$currentrouter->showpanel == 1) 
					{
						$routepanelcount++;
						if (isset($currentrouter->showpaneltotal) && (int)$currentrouter->showpaneltotal == 1) 
						{
							$routepaneltotalcount++;
						}
					}

					if (isset($currentrouter->showpanel) && (int)$currentrouter->showpanel == 1) 
					{
						$scripttext .= 'YMaps.Events.observe('.$router2name.', '.$router2name.'.Events.Success, function () {'."\n";
						$scripttext .= ' var total_km = '.$router2name.'.getDistance();'."\n";
						$scripttext .= ' var total_time = '.$router2name.'.getDuration();'."\n";
						$scripttext .= ' total_km = total_km / 1000.;'."\n";
						$scripttext .= ' total_time = total_time / 60.;'."\n";
						$scripttext .= ' total_km = total_km.toFixed(1);'."\n";
						$scripttext .= ' total_time = total_time.toFixed(1);'."\n";

						$scripttext .= '  document.getElementById("YMapsRoutePanel_Total'.$currentArticleId.'").innerHTML = "<p>';
						$scripttext .= JText::_('PLG_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_TOTAL_KM');
						$scripttext .= ' " + total_km + " ';
						$scripttext .= JText::_('PLG_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_KM');
						$scripttext .= ', ';
						$scripttext .= JText::_('PLG_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_TOTAL_TIME');
						if (isset($currentrouter->checktraffic) && (int)$currentrouter->checktraffic == 1)
						{
							$scripttext .= ' '.JText::_('PLG_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_JAM');
						}					
						$scripttext .= ' " + total_time + " ';
						$scripttext .= JText::_('PLG_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_TIME');
						$scripttext .= '</p>";' ."\n";
						$scripttext .= '}); '."\n";
					}
				}

			}
			
			
			if (isset($currentrouter->showdescription) && (int)$currentrouter->showdescription == 1) 
			{
				if ($currentrouter->description != "")
				{
					$routeHTMLdescription .= '<h2>';
					$routeHTMLdescription .= htmlspecialchars($currentrouter->description, ENT_QUOTES, 'UTF-8');
					$routeHTMLdescription .= '</h2>';
				}
				if ($currentrouter->descriptionhtml != "")
				{
					$routeHTMLdescription .= str_replace("'", "\'", str_replace(array("\r", "\r\n", "\n"), '', $currentrouter->descriptionhtml));
				}
			}
			
			
			

			if ($currentrouter->kmllayerymapsml != "")
			{
				$kml1 = 'YMapsML'.$routername;
				$scripttext .= 'var '.$kml1.' = new YMaps.YMapsML("'.$currentrouter->kmllayerymapsml.'");' ."\n";
				$scripttext .= 'map'.$currentArticleId.'.addOverlay('.$kml1.');' ."\n";

				$scripttext .= 'YMaps.Events.observe('.$kml1.', '.$kml1.'.Events.Fault, function ('.$kml1.', error) {' ."\n";
				$scripttext .= '    alert(\''.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_YMAPSML').'\' + error);' ."\n";
				//$scripttext .= '    alert("Error: " + error);' ."\n";
				$scripttext .= '});' ."\n";
				
			}

			if ($currentrouter->kmllayerkml != "")
			{
				$kml2 = 'KML'.$routername;
				$scripttext .= 'var '.$kml2.' = new YMaps.KML("'.$currentrouter->kmllayerkml.'");' ."\n";
				$scripttext .= 'map'.$currentArticleId.'.addOverlay('.$kml2.');' ."\n";
				
				$scripttext .= 'YMaps.Events.observe('.$kml2.', '.$kml2.'.Events.Fault, function ('.$kml2.', error) {' ."\n";
                $scripttext .= '	alert(\''.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_KML').'\' + error);' ."\n";
				//$scripttext .= '    alert("Error: " + error);' ."\n";
				$scripttext .= '});' ."\n";
			}

			if ($currentrouter->kmllayergpx != "")
			{
				$kml3 = 'GPX'.$routername;
				$scripttext .= 'var '.$kml3.' = new YMaps.GPX("'.$currentrouter->kmllayergpx.'");' ."\n";
				$scripttext .= 'map'.$currentArticleId.'.addOverlay('.$kml3.');' ."\n";

				$scripttext .= 'YMaps.Events.observe('.$kml3.', '.$kml3.'.Events.Fault, function ('.$kml3.', error) {' ."\n";
				$scripttext .= '    alert(\''.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_GPX').'\' + error);' ."\n";
				//$scripttext .= '    alert("Error: " + error);' ."\n";
				$scripttext .= '});' ."\n";
			}
			
		}
		// End for each Route
		
		if ($routepanelcount > 1 || $routepanelcount == 0 || $routepaneltotalcount == 0)
		{
			$scripttext .= 'var toHideRouteDiv = document.getElementById("YMapsRoutePanel_Total'.$currentArticleId.'");' ."\n";
			$scripttext .= 'toHideRouteDiv.style.display = "none";' ."\n";
			//$scripttext .= 'alert("Hide because > 1 or = 0");';
		}

		if ($routeHTMLdescription != "")
		{
			$scripttext .= '  document.getElementById("YMapsRoutePanel_Description'. $currentArticleId.'").innerHTML =  "<p>'. $routeHTMLdescription .'</p>";'."\n";
		}
		
	}


	// Paths
	if (isset($paths) && !empty($paths)) 
	{
		foreach ($paths as $key => $currentpath) 
		{
			$scripttext .= ' var spth'.$currentpath->id.' = new YMaps.Style();'."\n";
			$scripttext .= ' spth'.$currentpath->id.'.lineStyle = new YMaps.LineStyle();'."\n";
			$scripttext .= ' spth'.$currentpath->id.'.lineStyle.strokeColor = \''.$currentpath->color.'\';'."\n";
			$scripttext .= ' spth'.$currentpath->id.'.lineStyle.strokeWidth = \''.$currentpath->width.'\';'."\n";
			$scripttext .= ' YMaps.Styles.add("custom#PolyLine'.$currentpath->id.'", spth'.$currentpath->id.');'."\n";

			$scripttext .= ' var pl'.$currentpath->id.' = new YMaps.Polyline([ '."\n";
			$scripttext .=' new YMaps.GeoPoint('.str_replace(";","), new YMaps.GeoPoint(", $currentpath->path).') '."\n";
			$scripttext .= ' ]); '."\n";

			$scripttext .= 'pl'.$currentpath->id.'.setStyle("custom#PolyLine'.$currentpath->id.'");'."\n";
			$scripttext .= 'pl'.$currentpath->id.'.setBalloonContent("'.htmlspecialchars(str_replace('\\', '/', $currentpath->title), ENT_QUOTES, 'UTF-8').'");' ."\n";
			$scripttext .= 'map'.$currentArticleId.'.addOverlay(pl'.$currentpath->id.');'."\n";

		}
	}


	if (isset($map->kmllayer) && $map->kmllayer != "") 
	{
		$scripttext .= 'var klmLayer = new YMaps.YMapsML("'.$map->kmllayer.'");' ."\n";
		$scripttext .= 'map'.$currentArticleId.'.addOverlay(klmLayer);' ."\n";
	}


	$context_suffix = 'map';

	if ($map->kmllayer != "")
	{
		$kml1 = 'YMapsML'.$context_suffix;
		$scripttext .= 'var '.$kml1.' = new YMaps.YMapsML("'.$map->kmllayer.'");' ."\n";
		$scripttext .= 'map'.$currentArticleId.'.addOverlay('.$kml1.');' ."\n";

		$scripttext .= 'YMaps.Events.observe('.$kml1.', '.$kml1.'.Events.Fault, function ('.$kml1.', error) {' ."\n";
		$scripttext .= '    alert(\''.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_YMAPSML').'\' + error);' ."\n";
		//$scripttext .= '    alert("Error: " + error);' ."\n";
		$scripttext .= '});' ."\n";
		
	}

	if ($map->kmllayerkml != "")
	{
		$kml2 = 'KML'.$context_suffix;
		$scripttext .= 'var '.$kml2.' = new YMaps.KML("'.$map->kmllayerkml.'");' ."\n";
		$scripttext .= 'map'.$currentArticleId.'.addOverlay('.$kml2.');' ."\n";
		
		$scripttext .= 'YMaps.Events.observe('.$kml2.', '.$kml2.'.Events.Fault, function ('.$kml2.', error) {' ."\n";
		$scripttext .= '	alert(\''.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_KML').'\' + error);' ."\n";
		//$scripttext .= '    alert("Error: " + error);' ."\n";
		$scripttext .= '});' ."\n";
	}

	if ($map->kmllayergpx != "")
	{
		$kml3 = 'GPX'.$context_suffix;
		$scripttext .= 'var '.$kml3.' = new YMaps.GPX("'.$map->kmllayergpx.'");' ."\n";
		$scripttext .= 'map'.$currentArticleId.'.addOverlay('.$kml3.');' ."\n";

		$scripttext .= 'YMaps.Events.observe('.$kml3.', '.$kml3.'.Events.Fault, function ('.$kml3.', error) {' ."\n";
		$scripttext .= '    alert(\''.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_GPX').'\' + error);' ."\n";
		//$scripttext .= '    alert("Error: " + error);' ."\n";
		$scripttext .= '});' ."\n";
	}

	
	$scripttext .= '});' ."\n";

	// Find option Begin
	if (isset($map->findcontrol) && (int)$map->findcontrol == 1) 
	{
			$scripttext .= 'function showAddressByGeocoding'.$currentArticleId.'(value) {' ."\n";
			// Delete Previous Result
			$scripttext .= '    map'.$currentArticleId.'.removeOverlay(geoResult'.$currentArticleId.');' ."\n";

			// Geocoding
			$scripttext .= '   var geocoder'.$currentArticleId.' = new YMaps.Geocoder(value, {results: 1, boundedBy: map'.$currentArticleId.'.getBounds()});' ."\n";

			// Success geocoding
			$scripttext .= '   YMaps.Events.observe(geocoder'.$currentArticleId.', geocoder'.$currentArticleId.'.Events.Load, function () {' ."\n";
			// if find then add to map
			// set center map
			$scripttext .= '        if (this.length()) ' ."\n";
			$scripttext .= '		{' ."\n";
			$scripttext .= '            geoResult'.$currentArticleId.' = this.get(0);' ."\n";
			$scripttext .= '            map'.$currentArticleId.'.addOverlay(geoResult'.$currentArticleId.');' ."\n";
			$scripttext .= '            map'.$currentArticleId.'.setBounds(geoResult'.$currentArticleId.'.getBounds());' ."\n";
			// add route
			if (isset($map->findroute) && (int)$map->findroute == 1) 
			{
			
				$scripttext .= '       map'.$currentArticleId.'.removeOverlay(geoRoute'.$currentArticleId.');' ."\n";
				$scripttext .= '       geoRoute'.$currentArticleId.' = new YMaps.Router([geoResult'.$currentArticleId.'.getGeoPoint(), mapcenter'.$currentArticleId.'],[],'."\n";
				$scripttext .= '       { viewAutoApply: true });'."\n";
				$scripttext .= '       map'.$currentArticleId.'.addOverlay(geoRoute'.$currentArticleId.');'."\n";
				
				$scripttext .= '       YMaps.Events.observe(geoRoute'.$currentArticleId.', geoRoute'.$currentArticleId.'.Events.Success, function () {'."\n";
				$scripttext .= '       		geoRoute'.$currentArticleId.'.getWayPoint(0).setIconContent(\''.JText::_('PLG_ZHYANDEXMAP_MAP_FIND_GEOCODING_START_POINT').'\');'."\n";
				//$scripttext .= '       		geoRoute'.$currentArticleId.'.getWayPoint(0).setIconContent(\'Точка отправления\');'."\n";
				
				$scripttext .= '       		geoRoute'.$currentArticleId.'.getWayPoint(1).setIconContent(\''.JText::_('PLG_ZHYANDEXMAP_MAP_FIND_GEOCODING_END_POINT').'\');'."\n";
				//$scripttext .= '       		geoRoute'.$currentArticleId.'.getWayPoint(1).setIconContent(\'Точка прибытия\');'."\n";
				$scripttext .= '       		geoRoute'.$currentArticleId.'.getWayPoint(1).setBalloonContent(\''.JText::_('PLG_ZHYANDEXMAP_MAP_FIND_GEOCODING_END_POINT').'\');'."\n";
				//$scripttext .= '       		geoRoute'.$currentArticleId.'.getWayPoint(1).setBalloonContent(\'Точка прибытия\');'."\n";
				$scripttext .= '       });'."\n";	
				
				$scripttext .= '       YMaps.Events.observe(geoRoute'.$currentArticleId.', geoRoute'.$currentArticleId.'.Events.GeocodeError, function (link, number) {'."\n";
				$scripttext .= '         alert(\''.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_GEOCODING').'\' + number);'."\n";
				//$scripttext .= '         alert(\'Error while geocoding of point #\' + number);'."\n";
				$scripttext .= '       }); '."\n";
				
				$scripttext .= '       YMaps.Events.observe(geoRoute'.$currentArticleId.', geoRoute'.$currentArticleId.'.Events.RouteError, function (link, number) {'."\n";
				$scripttext .= '          alert(\''.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_UNABLE_DRAW_ROUTE').'\' + number);'."\n";
				//$scripttext .= '          alert(\'Невозможно отобразить маршрут до точки #\' + number);'."\n";
				$scripttext .= '       }); '."\n";
			}
			// end add route
			$scripttext .= '        }' ."\n";
			$scripttext .= '		else ' ."\n";
			$scripttext .= '		{' ."\n";
			$scripttext .= '            alert("'.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_FIND_GEOCODING').'");' ."\n";
			//$scripttext .= '            alert("Данные не найдены");' ."\n";
			$scripttext .= '        }' ."\n";
			$scripttext .= '    });' ."\n";

			// Failure geocoding
			$scripttext .= '    YMaps.Events.observe(geocoder'.$currentArticleId.', geocoder'.$currentArticleId.'.Events.Fault, function (geocoder'.$currentArticleId.', error) {' ."\n";
			$scripttext .= '        alert("'.JText::_('PLG_ZHYANDEXMAP_MAP_ERROR_FIND_GEOCODING_ERROR').'" + error);' ."\n";
			//$scripttext .= '        alert("Geocoding error: " + error);' ."\n";
			$scripttext .= '    })' ."\n";
			$scripttext .= '};' ."\n";
	}
	// Find option End


	
	$scripttext .= '/*]]>*/</script>' ."\n";
	
	// Script end


	$this->scripttext = $scripttext;
	$this->scripthead = $scripthead;
	if ($loadmodules != "")
	{
		$this->loadmodules = $loadmodules;
	}

	
	return true;
	}



}
